#ifndef _CONSOLEOUTPUT_H_
	#define _CONSOLEOUTPUT_H_

#include "ArchiveDescription.h"

class CConsoleOutput
{
	HANDLE m_hFile;
	HANDLE m_hFileMap;
	LPSTR  m_lpData;
	bool m_bSaveList;
	bool m_bDoOemConversion;
	void ReleaseContents();
public:
	void SetOemConversion(bool bDoConvertion=true){m_bDoOemConversion=bDoConvertion;}

//	int ParseNExecuteCommand(int idx,CArchiveDescription *pad,LPCSTR lpArcFile=NULL,LPCSTR lpFile=NULL);
	CConsoleOutput(bool bSaveList=true);
	~CConsoleOutput(){ ReleaseContents(); }

	LPCSTR GetOutputData(){return m_lpData;}
	int ExecuteCommand(LPCSTR lpCommand,LPCSTR lpInput=NULL);
};

#define MAEL_CANT_CREATE_PROCESS 0x27272727

#endif //_CONSOLEOUTPUT_H_