/*----------Console application (CONSPAWN.EXE) code-----------------------
This program (CONSPAWN) is launched with a hidden console that inherits 
the redirected standard handles of the Win32 application. The application 
that CONSPAWN launches in the same hidden console inherits the same redirected 
standard handles. This behavior redirects the standard handles of the MS-DOS 
application to be launched to the pipe created in the parent Win32 application. 
-------------------------------------------------------------------------*/ 
#include <windows.h>
#include <stdio.h>

int main (int argc, char *argv[])
{
    BOOL                bRet = FALSE;
    STARTUPINFO         si   = {0};
    PROCESS_INFORMATION pi   = {0};

    // Make child process use this app's standard files.
    si.cb = sizeof(si);
    si.dwFlags    = STARTF_USESTDHANDLES;
    si.hStdInput  = GetStdHandle (STD_INPUT_HANDLE);
    si.hStdOutput = GetStdHandle (STD_OUTPUT_HANDLE);
    si.hStdError  = GetStdHandle (STD_ERROR_HANDLE);

    bRet = CreateProcess (NULL, argv[1],
                     NULL, NULL,
                     TRUE, 0,
                     NULL, NULL,
                     &si, &pi
                     );
    if (bRet)
    {
        WaitForSingleObject (pi.hProcess, INFINITE);
		int ExitCode;
		GetExitCodeProcess(pi.hProcess,(LPDWORD)&ExitCode);
        CloseHandle (pi.hProcess);
        CloseHandle (pi.hThread);
		return ExitCode;
    }

	printf("CONSPAWN: Error executing command \"%s\".\n",argv[1]);

	return -1;
}