#ifndef _ARCHIVERMANAGER_H_
	#define _ARCHIVERMANAGER_H_

#include "ArchiveDescription.h"
#include "wcx.h"
#include "ArchiverEngine.h"

class CArchiverManager
{
	CArchiveDescription *m_pad;
	int m_iArchiverCount;
	CArchiveDescription *FindArchiveDescriptionForExt(char *ext,int &iPrevIdx);
	BOOL CheckArchiveID(char *szArcPath,CArchiveDescription *pad);
public:
	CArchiverManager();
	int LoadArchiveDescriptions(char *szIniName){return m_iArchiverCount=CArchiveDescription::LoadArchiveDescriptions(&m_pad,szIniName);}
	~CArchiverManager(){delete[] m_pad;}
	CArchiverEngine *OpenArchive(tOpenArchiveData* ArchiveData,BOOL bCreate=FALSE);
	int CloseArchive(CArchiverEngine *ae);
};

#endif //_ARCHIVERMANAGER_H_